diff --git a/src/bin/pg_combinebackup/backup_label.c b/src/bin/pg_combinebackup/backup_label.c
new file mode 100644
index 0000000000..2a62aa6fad
--- /dev/null
+++ b/src/bin/pg_combinebackup/backup_label.c
@@ -0,0 +1,281 @@
+/*-------------------------------------------------------------------------
+ *
+ * Read and manipulate backup label files
+ *
+ * Portions Copyright (c) 1996-2023, PostgreSQL Global Development Group
+ * Portions Copyright (c) 1994, Regents of the University of California
+ *
+ * src/bin/pg_combinebackup/backup_label.c
+ *
+ *-------------------------------------------------------------------------
+ */
+#include "postgres_fe.h"
+
+#include <unistd.h>
+
+#include "access/xlogdefs.h"
+#include "backup_label.h"
+#include "common/logging.h"
+#include "common/file_perm.h"
+#include "write_manifest.h"
+
+static int	get_eol_offset(StringInfo buf);
+static bool line_starts_with(char *s, char *e, char *match, char **sout);
+static bool parse_lsn(char *s, char *e, XLogRecPtr *lsn, char **c);
+static bool parse_tli(char *s, char *e, TimeLineID *tli);
+
+/*
+ * Parse a backup label file, starting at buf->cursor.
+ *
+ * We expect to find a START WAL LOCATION line, followed by a LSN, followed
+ * by a space; the resulting LSN is stored into *start_lsn.
+ *
+ * We expect to find a START TIMELINE line, followed by a TLI, followed by
+ * a newline; the resulting TLI is stored into *start_tli.
+ *
+ * We expect to find either both INCREMENTAL FROM LSN and INCREMENTAL FROM TLI
+ * or neither. If these are found, they should be followed by an LSN or TLI
+ * respectively and then by a newline, and the values will be stored into
+ * *previous_lsn and *previous_tli, respectively.
+ *
+ * Other lines in the provided backup_label data are ignored. filename is used
+ * for error reporting; errors are fatal.
+ */
+void
+parse_backup_label(char *filename, StringInfo buf,
+				   TimeLineID *start_tli, XLogRecPtr *start_lsn,
+				   TimeLineID *previous_tli, XLogRecPtr *previous_lsn)
+{
+	int			found = 0;
+
+	*start_tli = 0;
+	*start_lsn = InvalidXLogRecPtr;
+	*previous_tli = 0;
+	*previous_lsn = InvalidXLogRecPtr;
+
+	while (buf->cursor < buf->len)
+	{
+		char	   *s = &buf->data[buf->cursor];
+		int			eo = get_eol_offset(buf);
+		char	   *e = &buf->data[eo];
+		char	   *c;
+
+		if (line_starts_with(s, e, "START WAL LOCATION: ", &s))
+		{
+			if (!parse_lsn(s, e, start_lsn, &c))
+				pg_fatal("%s: could not parse START WAL LOCATION",
+						 filename);
+			if (c >= e || *c != ' ')
+				pg_fatal("%s: improper terminator for START WAL LOCATION",
+						 filename);
+			found |= 1;
+		}
+		else if (line_starts_with(s, e, "START TIMELINE: ", &s))
+		{
+			if (!parse_tli(s, e, start_tli))
+				pg_fatal("%s: could not parse TLI for START TIMELINE",
+						 filename);
+			if (*start_tli == 0)
+				pg_fatal("%s: invalid TLI", filename);
+			found |= 2;
+		}
+		else if (line_starts_with(s, e, "INCREMENTAL FROM LSN: ", &s))
+		{
+			if (!parse_lsn(s, e, previous_lsn, &c))
+				pg_fatal("%s: could not parse INCREMENTAL FROM LSN",
+						 filename);
+			if (c >= e || *c != '\n')
+				pg_fatal("%s: improper terminator for INCREMENTAL FROM LSN",
+						 filename);
+			found |= 4;
+		}
+		else if (line_starts_with(s, e, "INCREMENTAL FROM TLI: ", &s))
+		{
+			if (!parse_tli(s, e, previous_tli))
+				pg_fatal("%s: could not parse INCREMENTAL FROM TLI",
+						 filename);
+			if (*previous_tli == 0)
+				pg_fatal("%s: invalid TLI", filename);
+			found |= 8;
+		}
+
+		buf->cursor = eo;
+	}
+
+	if ((found & 1) == 0)
+		pg_fatal("%s: could not find START WAL LOCATION", filename);
+	if ((found & 2) == 0)
+		pg_fatal("%s: could not find START TIMELINE", filename);
+	if ((found & 4) != 0 && (found & 8) == 0)
+		pg_fatal("%s: INCREMENTAL FROM LSN requires INCREMENTAL FROM TLI", filename);
+	if ((found & 8) != 0 && (found & 4) == 0)
+		pg_fatal("%s: INCREMENTAL FROM TLI requires INCREMENTAL FROM LSN", filename);
+}
+
+/*
+ * Write a backup label file to the output directory.
+ *
+ * This will be identical to the provided backup_label file, except that the
+ * INCREMENTAL FROM LSN and INCREMENTAL FROM TLI lines will be omitted.
+ *
+ * The new file will be checksummed using the specified algorithm. If
+ * mwriter != NULL, it will be added to the manifest.
+ */
+void
+write_backup_label(char *output_directory, StringInfo buf,
+				   pg_checksum_type checksum_type, manifest_writer *mwriter)
+{
+	char		output_filename[MAXPGPATH];
+	int			output_fd;
+	pg_checksum_context checksum_ctx;
+	uint8		checksum_payload[PG_CHECKSUM_MAX_LENGTH];
+	int			checksum_length;
+
+	pg_checksum_init(&checksum_ctx, checksum_type);
+
+	snprintf(output_filename, MAXPGPATH, "%s/backup_label", output_directory);
+
+	if ((output_fd = open(output_filename,
+						  O_WRONLY | O_CREAT | O_EXCL | PG_BINARY,
+						  pg_file_create_mode)) < 0)
+		pg_fatal("could not open file \"%s\": %m", output_filename);
+
+	while (buf->cursor < buf->len)
+	{
+		char	   *s = &buf->data[buf->cursor];
+		int			eo = get_eol_offset(buf);
+		char	   *e = &buf->data[eo];
+
+		if (!line_starts_with(s, e, "INCREMENTAL FROM LSN: ", NULL) &&
+			!line_starts_with(s, e, "INCREMENTAL FROM TLI: ", NULL))
+		{
+			ssize_t		wb;
+
+			wb = write(output_fd, s, e - s);
+			if (wb != e - s)
+			{
+				if (wb < 0)
+					pg_fatal("could not write file \"%s\": %m", output_filename);
+				else
+					pg_fatal("could not write file \"%s\": wrote only %d of %d bytes",
+							 output_filename, (int) wb, (int) (e - s));
+			}
+			if (pg_checksum_update(&checksum_ctx, (uint8 *) s, e - s) < 0)
+				pg_fatal("could not update checksum of file \"%s\"",
+						 output_filename);
+		}
+
+		buf->cursor = eo;
+	}
+
+	if (close(output_fd) != 0)
+		pg_fatal("could not close \"%s\": %m", output_filename);
+
+	checksum_length = pg_checksum_final(&checksum_ctx, checksum_payload);
+
+	if (mwriter != NULL)
+	{
+		struct stat sb;
+
+		/*
+		 * We could track the length ourselves, but must stat() to get the
+		 * mtime.
+		 */
+		if (stat(output_filename, &sb) < 0)
+			pg_fatal("could not stat file \"%s\": %m", output_filename);
+		add_file_to_manifest(mwriter, "backup_label", sb.st_size,
+							 sb.st_mtime, checksum_type,
+							 checksum_length, checksum_payload);
+	}
+}
+
+/*
+ * Return the offset at which the next line in the buffer starts, or there
+ * is none, the offset at which the buffer ends.
+ *
+ * The search begins at buf->cursor.
+ */
+static int
+get_eol_offset(StringInfo buf)
+{
+	int			eo = buf->cursor;
+
+	while (eo < buf->len)
+	{
+		if (buf->data[eo] == '\n')
+			return eo + 1;
+		++eo;
+	}
+
+	return eo;
+}
+
+/*
+ * Test whether the line that runs from s to e (inclusive of *s, but not
+ * inclusive of *e) starts with the match string provided, and return true
+ * or false according to whether or not this is the case.
+ *
+ * If the function returns true and if *sout != NULL, stores a pointer to the
+ * byte following the match into *sout.
+ */
+static bool
+line_starts_with(char *s, char *e, char *match, char **sout)
+{
+	while (s < e && *match != '\0' && *s == *match)
+		++s, ++match;
+
+	if (*match == '\0' && sout != NULL)
+		*sout = s;
+
+	return (*match == '\0');
+}
+
+/*
+ * Parse an LSN starting at s and not stopping at or before e. The return value
+ * is true on success and otherwise false. On success, stores the result into
+ * *lsn and sets *c to the first character that is not part of the LSN.
+ */
+static bool
+parse_lsn(char *s, char *e, XLogRecPtr *lsn, char **c)
+{
+	char		save = *e;
+	int			nchars;
+	bool		success;
+	unsigned	hi;
+	unsigned	lo;
+
+	*e = '\0';
+	success = (sscanf(s, "%X/%X%n", &hi, &lo, &nchars) == 2);
+	*e = save;
+
+	if (success)
+	{
+		*lsn = ((XLogRecPtr) hi) << 32 | (XLogRecPtr) lo;
+		*c = s + nchars;
+	}
+
+	return success;
+}
+
+/*
+ * Parse a TLI starting at s and stopping at or before e. The return value is
+ * true on success and otherwise false. On success, stores the result into
+ * *tli. If the first character that is not part of the TLI is anything other
+ * than a newline, that is deemed a failure.
+ */
+static bool
+parse_tli(char *s, char *e, TimeLineID *tli)
+{
+	char		save = *e;
+	int			nchars;
+	bool		success;
+
+	*e = '\0';
+	success = (sscanf(s, "%u%n", tli, &nchars) == 1);
+	*e = save;
+
+	if (success && s[nchars] != '\n')
+		success = false;
+
+	return success;
+}
diff --git a/src/bin/pg_combinebackup/backup_label.h b/src/bin/pg_combinebackup/backup_label.h
new file mode 100644
index 0000000000..08d6ed67a9
--- /dev/null
+++ b/src/bin/pg_combinebackup/backup_label.h
@@ -0,0 +1,29 @@
+/*-------------------------------------------------------------------------
+ *
+ * Read and manipulate backup label files
+ *
+ * Portions Copyright (c) 1996-2023, PostgreSQL Global Development Group
+ * Portions Copyright (c) 1994, Regents of the University of California
+ *
+ * src/bin/pg_combinebackup/backup_label.h
+ *
+ *-------------------------------------------------------------------------
+ */
+#ifndef BACKUP_LABEL_H
+#define BACKUP_LABEL_H
+
+#include "common/checksum_helper.h"
+#include "lib/stringinfo.h"
+
+struct manifest_writer;
+
+extern void parse_backup_label(char *filename, StringInfo buf,
+							   TimeLineID *start_tli,
+							   XLogRecPtr *start_lsn,
+							   TimeLineID *previous_tli,
+							   XLogRecPtr *previous_lsn);
+extern void write_backup_label(char *output_directory, StringInfo buf,
+							   pg_checksum_type checksum_type,
+							   struct manifest_writer *mwriter);
+
+#endif							/* BACKUP_LABEL_H */
diff --git a/src/bin/pg_combinebackup/copy_file.c b/src/bin/pg_combinebackup/copy_file.c
new file mode 100644
index 0000000000..8ba6cc09e4
--- /dev/null
+++ b/src/bin/pg_combinebackup/copy_file.c
@@ -0,0 +1,169 @@
+/*
+ * Copy entire files.
+ *
+ * Portions Copyright (c) 1996-2023, PostgreSQL Global Development Group
+ * Portions Copyright (c) 1994, Regents of the University of California
+ *
+ * src/bin/pg_combinebackup/copy_file.h
+ *
+ *-------------------------------------------------------------------------
+ */
+#include "postgres_fe.h"
+
+#ifdef HAVE_COPYFILE_H
+#include <copyfile.h>
+#endif
+#include <fcntl.h>
+#include <sys/stat.h>
+#include <unistd.h>
+
+#include "common/file_perm.h"
+#include "common/logging.h"
+#include "copy_file.h"
+
+static void copy_file_blocks(const char *src, const char *dst,
+							 pg_checksum_context *checksum_ctx);
+
+#ifdef WIN32
+static void copy_file_copyfile(const char *src, const char *dst);
+#endif
+
+/*
+ * Copy a regular file, optionally computing a checksum, and emitting
+ * appropriate debug messages. But if we're in dry-run mode, then just emit
+ * the messages and don't copy anything.
+ */
+void
+copy_file(const char *src, const char *dst,
+		  pg_checksum_context *checksum_ctx, bool dry_run)
+{
+	/*
+	 * In dry-run mode, we don't actually copy anything, nor do we read any
+	 * data from the source file, but we do verify that we can open it.
+	 */
+	if (dry_run)
+	{
+		int			fd;
+
+		if ((fd = open(src, O_RDONLY | PG_BINARY)) < 0)
+			pg_fatal("could not open \"%s\": %m", src);
+		if (close(fd) < 0)
+			pg_fatal("could not close \"%s\": %m", src);
+	}
+
+	/*
+	 * If we don't need to compute a checksum, then we can use any special
+	 * operating system primitives that we know about to copy the file; this
+	 * may be quicker than a naive block copy.
+	 */
+	if (checksum_ctx->type != CHECKSUM_TYPE_NONE)
+	{
+		char	   *strategy_name = NULL;
+		void		(*strategy_implementation) (const char *, const char *) = NULL;
+
+#ifdef WIN32
+		strategy_name = "CopyFile";
+		strategy_implementation = copy_file_copyfile;
+#endif
+
+		if (strategy_name != NULL)
+		{
+			if (dry_run)
+				pg_log_debug("would copy \"%s\" to \"%s\" using strategy %s",
+							 src, dst, strategy_name);
+			else
+			{
+				pg_log_debug("copying \"%s\" to \"%s\" using strategy %s",
+							 src, dst, strategy_name);
+				(*strategy_implementation) (src, dst);
+			}
+			return;
+		}
+	}
+
+	/*
+	 * Fall back to the simple approach of reading and writing all the blocks,
+	 * feeding them into the checksum context as we go.
+	 */
+	if (dry_run)
+	{
+		if (checksum_ctx->type == CHECKSUM_TYPE_NONE)
+			pg_log_debug("would copy \"%s\" to \"%s\"",
+						 src, dst);
+		else
+			pg_log_debug("would copy \"%s\" to \"%s\" and checksum with %s",
+						 src, dst, pg_checksum_type_name(checksum_ctx->type));
+	}
+	else
+	{
+		if (checksum_ctx->type == CHECKSUM_TYPE_NONE)
+			pg_log_debug("copying \"%s\" to \"%s\"",
+						 src, dst);
+		else
+			pg_log_debug("copying \"%s\" to \"%s\" and checksumming with %s",
+						 src, dst, pg_checksum_type_name(checksum_ctx->type));
+		copy_file_blocks(src, dst, checksum_ctx);
+	}
+}
+
+/*
+ * Copy a file block by block, and optionally compute a checksum as we go.
+ */
+static void
+copy_file_blocks(const char *src, const char *dst,
+				 pg_checksum_context *checksum_ctx)
+{
+	int			src_fd;
+	int			dest_fd;
+	uint8	   *buffer;
+	const int	buffer_size = 50 * BLCKSZ;
+	ssize_t		rb;
+	unsigned	offset = 0;
+
+	if ((src_fd = open(src, O_RDONLY | PG_BINARY, 0)) < 0)
+		pg_fatal("could not open file \"%s\": %m", src);
+
+	if ((dest_fd = open(dst, O_WRONLY | O_CREAT | O_EXCL | PG_BINARY,
+						pg_file_create_mode)) < 0)
+		pg_fatal("could not open file \"%s\": %m", dst);
+
+	buffer = pg_malloc(buffer_size);
+
+	while ((rb = read(src_fd, buffer, buffer_size)) > 0)
+	{
+		ssize_t		wb;
+
+		if ((wb = write(dest_fd, buffer, rb)) != rb)
+		{
+			if (wb < 0)
+				pg_fatal("could not write file \"%s\": %m", dst);
+			else
+				pg_fatal("could not write file \"%s\": wrote only %d of %d bytes at offset %u",
+						 dst, (int) wb, (int) rb, offset);
+		}
+
+		if (pg_checksum_update(checksum_ctx, buffer, rb) < 0)
+			pg_fatal("could not update checksum of file \"%s\"", dst);
+
+		offset += rb;
+	}
+
+	if (rb < 0)
+		pg_fatal("could not read file \"%s\": %m", dst);
+
+	pg_free(buffer);
+	close(src_fd);
+	close(dest_fd);
+}
+
+#ifdef WIN32
+static void
+copy_file_copyfile(const char *src, const char *dst)
+{
+	if (CopyFile(src, dst, true) == 0)
+	{
+		_dosmaperr(GetLastError());
+		pg_fatal("could not copy \"%s\" to \"%s\": %m", src, dst);
+	}
+}
+#endif							/* WIN32 */
diff --git a/src/bin/pg_combinebackup/copy_file.h b/src/bin/pg_combinebackup/copy_file.h
new file mode 100644
index 0000000000..031030bacb
--- /dev/null
+++ b/src/bin/pg_combinebackup/copy_file.h
@@ -0,0 +1,19 @@
+/*
+ * Copy entire files.
+ *
+ * Portions Copyright (c) 1996-2023, PostgreSQL Global Development Group
+ * Portions Copyright (c) 1994, Regents of the University of California
+ *
+ * src/bin/pg_combinebackup/copy_file.h
+ *
+ *-------------------------------------------------------------------------
+ */
+#ifndef COPY_FILE_H
+#define COPY_FILE_H
+
+#include "common/checksum_helper.h"
+
+extern void copy_file(const char *src, const char *dst,
+					  pg_checksum_context *checksum_ctx, bool dry_run);
+
+#endif							/* COPY_FILE_H */
diff --git a/src/bin/pg_combinebackup/load_manifest.c b/src/bin/pg_combinebackup/load_manifest.c
new file mode 100644
index 0000000000..d0b8de7912
--- /dev/null
+++ b/src/bin/pg_combinebackup/load_manifest.c
@@ -0,0 +1,245 @@
+/*-------------------------------------------------------------------------
+ *
+ * Load data from a backup manifest into memory.
+ *
+ * Portions Copyright (c) 1996-2023, PostgreSQL Global Development Group
+ * Portions Copyright (c) 1994, Regents of the University of California
+ *
+ * src/bin/pg_combinebackup/load_manifest.c
+ *
+ *-------------------------------------------------------------------------
+ */
+
+#include "postgres_fe.h"
+
+#include <sys/stat.h>
+#include <unistd.h>
+
+#include "common/hashfn.h"
+#include "common/logging.h"
+#include "common/parse_manifest.h"
+#include "load_manifest.h"
+
+/*
+ * For efficiency, we'd like our hash table containing information about the
+ * manifest to start out with approximately the correct number of entries.
+ * There's no way to know the exact number of entries without reading the whole
+ * file, but we can get an estimate by dividing the file size by the estimated
+ * number of bytes per line.
+ *
+ * This could be off by about a factor of two in either direction, because the
+ * checksum algorithm has a big impact on the line lengths; e.g. a SHA512
+ * checksum is 128 hex bytes, whereas a CRC-32C value is only 8, and there
+ * might be no checksum at all.
+ */
+#define ESTIMATED_BYTES_PER_MANIFEST_LINE	100
+
+/*
+ * Define a hash table which we can use to store information about the files
+ * mentioned in the backup manifest.
+ */
+static uint32 hash_string_pointer(char *s);
+#define SH_PREFIX		manifest_files
+#define SH_ELEMENT_TYPE	manifest_file
+#define SH_KEY_TYPE		char *
+#define	SH_KEY			pathname
+#define SH_HASH_KEY(tb, key)	hash_string_pointer(key)
+#define SH_EQUAL(tb, a, b)		(strcmp(a, b) == 0)
+#define	SH_SCOPE		extern
+#define SH_RAW_ALLOCATOR	pg_malloc0
+#define SH_DEFINE
+#include "lib/simplehash.h"
+
+static void record_manifest_details_for_file(JsonManifestParseContext *context,
+											 char *pathname, size_t size,
+											 pg_checksum_type checksum_type,
+											 int checksum_length,
+											 uint8 *checksum_payload);
+static void record_manifest_details_for_wal_range(JsonManifestParseContext *context,
+												  TimeLineID tli,
+												  XLogRecPtr start_lsn,
+												  XLogRecPtr end_lsn);
+static void report_manifest_error(JsonManifestParseContext *context,
+								  const char *fmt,...)
+			pg_attribute_printf(2, 3) pg_attribute_noreturn();
+
+/*
+ * Load backup_manifest files from an array of backups and produces an array
+ * of manifest_data objects.
+ *
+ * NB: Since load_backup_manifest() can return NULL, the resulting array could
+ * contain NULL entries.
+ */
+manifest_data **
+load_backup_manifests(int n_backups, char **backup_directories)
+{
+	manifest_data **result;
+	int			i;
+
+	result = pg_malloc(sizeof(manifest_data *) * n_backups);
+	for (i = 0; i < n_backups; ++i)
+		result[i] = load_backup_manifest(backup_directories[i]);
+
+	return result;
+}
+
+/*
+ * Parse the backup_manifest file in the named backup directory. Construct a
+ * hash table with information about all the files it mentions, and a linked
+ * list of all the WAL ranges it mentions.
+ *
+ * If the backup_manifest file simply doesn't exist, logs a warning and returns
+ * NULL. Any other error, or any error parsing the contents of the file, is
+ * fatal.
+ */
+manifest_data *
+load_backup_manifest(char *backup_directory)
+{
+	char		pathname[MAXPGPATH];
+	int			fd;
+	struct stat statbuf;
+	off_t		estimate;
+	uint32		initial_size;
+	manifest_files_hash *ht;
+	char	   *buffer;
+	int			rc;
+	JsonManifestParseContext context;
+	manifest_data *result;
+
+	/* Open the manifest file. */
+	snprintf(pathname, MAXPGPATH, "%s/backup_manifest", backup_directory);
+	if ((fd = open(pathname, O_RDONLY | PG_BINARY, 0)) < 0)
+	{
+		if (errno == EEXIST)
+		{
+			pg_log_warning("\"%s\" does not exist", pathname);
+			return NULL;
+		}
+		pg_fatal("could not open file \"%s\": %m", pathname);
+	}
+
+	/* Figure out how big the manifest is. */
+	if (fstat(fd, &statbuf) != 0)
+		pg_fatal("could not stat file \"%s\": %m", pathname);
+
+	/* Guess how large to make the hash table based on the manifest size. */
+	estimate = statbuf.st_size / ESTIMATED_BYTES_PER_MANIFEST_LINE;
+	initial_size = Min(PG_UINT32_MAX, Max(estimate, 256));
+
+	/* Create the hash table. */
+	ht = manifest_files_create(initial_size, NULL);
+
+	/*
+	 * Slurp in the whole file.
+	 *
+	 * This is not ideal, but there's currently no way to get pg_parse_json()
+	 * to perform incremental parsing.
+	 */
+	buffer = pg_malloc(statbuf.st_size);
+	rc = read(fd, buffer, statbuf.st_size);
+	if (rc != statbuf.st_size)
+	{
+		if (rc < 0)
+			pg_fatal("could not read file \"%s\": %m", pathname);
+		else
+			pg_fatal("could not read file \"%s\": read %d of %lld",
+					 pathname, rc, (long long int) statbuf.st_size);
+	}
+
+	/* Close the manifest file. */
+	close(fd);
+
+	/* Parse the manifest. */
+	result = pg_malloc0(sizeof(manifest_data));
+	result->files = ht;
+	context.private_data = result;
+	context.perfile_cb = record_manifest_details_for_file;
+	context.perwalrange_cb = record_manifest_details_for_wal_range;
+	context.error_cb = report_manifest_error;
+	json_parse_manifest(&context, buffer, statbuf.st_size);
+
+	/* All done. */
+	pfree(buffer);
+	return result;
+}
+
+/*
+ * Report an error while parsing the manifest.
+ *
+ * We consider all such errors to be fatal errors. The manifest parser
+ * expects this function not to return.
+ */
+static void
+report_manifest_error(JsonManifestParseContext *context, const char *fmt,...)
+{
+	va_list		ap;
+
+	va_start(ap, fmt);
+	pg_log_generic_v(PG_LOG_ERROR, PG_LOG_PRIMARY, gettext(fmt), ap);
+	va_end(ap);
+
+	exit(1);
+}
+
+/*
+ * Record details extracted from the backup manifest for one file.
+ */
+static void
+record_manifest_details_for_file(JsonManifestParseContext *context,
+								 char *pathname, size_t size,
+								 pg_checksum_type checksum_type,
+								 int checksum_length, uint8 *checksum_payload)
+{
+	manifest_data *manifest = context->private_data;
+	manifest_file *m;
+	bool		found;
+
+	/* Make a new entry in the hash table for this file. */
+	m = manifest_files_insert(manifest->files, pathname, &found);
+	if (found)
+		pg_fatal("duplicate path name in backup manifest: \"%s\"", pathname);
+
+	/* Initialize the entry. */
+	m->size = size;
+	m->checksum_type = checksum_type;
+	m->checksum_length = checksum_length;
+	m->checksum_payload = checksum_payload;
+}
+
+/*
+ * Record details extracted from the backup manifest for one WAL range.
+ */
+static void
+record_manifest_details_for_wal_range(JsonManifestParseContext *context,
+									  TimeLineID tli,
+									  XLogRecPtr start_lsn, XLogRecPtr end_lsn)
+{
+	manifest_data *manifest = context->private_data;
+	manifest_wal_range *range;
+
+	/* Allocate and initialize a struct describing this WAL range. */
+	range = palloc(sizeof(manifest_wal_range));
+	range->tli = tli;
+	range->start_lsn = start_lsn;
+	range->end_lsn = end_lsn;
+	range->prev = manifest->last_wal_range;
+	range->next = NULL;
+
+	/* Add it to the end of the list. */
+	if (manifest->first_wal_range == NULL)
+		manifest->first_wal_range = range;
+	else
+		manifest->last_wal_range->next = range;
+	manifest->last_wal_range = range;
+}
+
+/*
+ * Helper function for manifest_files hash table.
+ */
+static uint32
+hash_string_pointer(char *s)
+{
+	unsigned char *ss = (unsigned char *) s;
+
+	return hash_bytes(ss, strlen(s));
+}
diff --git a/src/bin/pg_combinebackup/load_manifest.h b/src/bin/pg_combinebackup/load_manifest.h
new file mode 100644
index 0000000000..2bfeeff156
--- /dev/null
+++ b/src/bin/pg_combinebackup/load_manifest.h
@@ -0,0 +1,67 @@
+/*-------------------------------------------------------------------------
+ *
+ * Load data from a backup manifest into memory.
+ *
+ * Portions Copyright (c) 1996-2023, PostgreSQL Global Development Group
+ * Portions Copyright (c) 1994, Regents of the University of California
+ *
+ * src/bin/pg_combinebackup/load_manifest.h
+ *
+ *-------------------------------------------------------------------------
+ */
+#ifndef LOAD_MANIFEST_H
+#define LOAD_MANIFEST_H
+
+#include "access/xlogdefs.h"
+#include "common/checksum_helper.h"
+
+/*
+ * Each file described by the manifest file is parsed to produce an object
+ * like this.
+ */
+typedef struct manifest_file
+{
+	uint32		status;			/* hash status */
+	char	   *pathname;
+	size_t		size;
+	pg_checksum_type checksum_type;
+	int			checksum_length;
+	uint8	   *checksum_payload;
+} manifest_file;
+
+#define SH_PREFIX		manifest_files
+#define SH_ELEMENT_TYPE	manifest_file
+#define SH_KEY_TYPE		char *
+#define	SH_SCOPE		extern
+#define SH_RAW_ALLOCATOR	pg_malloc0
+#define SH_DECLARE
+#include "lib/simplehash.h"
+
+/*
+ * Each WAL range described by the manifest file is parsed to produce an
+ * object like this.
+ */
+typedef struct manifest_wal_range
+{
+	TimeLineID	tli;
+	XLogRecPtr	start_lsn;
+	XLogRecPtr	end_lsn;
+	struct manifest_wal_range *next;
+	struct manifest_wal_range *prev;
+} manifest_wal_range;
+
+/*
+ * All the data parsed from a backup_manifest file.
+ */
+typedef struct manifest_data
+{
+	manifest_files_hash *files;
+	manifest_wal_range *first_wal_range;
+	manifest_wal_range *last_wal_range;
+} manifest_data;
+
+extern manifest_data *load_backup_manifest(char *backup_directory);
+extern manifest_data **load_backup_manifests(int n_backups,
+											 char **backup_directories);
+
+#endif							/* LOAD_MANIFEST_H */
diff --git a/src/bin/pg_combinebackup/meson.build b/src/bin/pg_combinebackup/meson.build
new file mode 100644
index 0000000000..bea0db405e
--- /dev/null
+++ b/src/bin/pg_combinebackup/meson.build
@@ -0,0 +1,29 @@
+# Copyright (c) 2022-2023, PostgreSQL Global Development Group
+
+pg_combinebackup_sources = files(
+  'pg_combinebackup.c',
+  'backup_label.c',
+  'copy_file.c',
+  'load_manifest.c',
+  'reconstruct.c',
+  'write_manifest.c',
+)
+
+if host_system == 'windows'
+  pg_combinebackup_sources += rc_bin_gen.process(win32ver_rc, extra_args: [
+    '--NAME', 'pg_combinebackup',
+    '--FILEDESC', 'pg_combinebackup - combine incremental backups',])
+endif
+
+pg_combinebackup = executable('pg_combinebackup',
+  pg_combinebackup_sources,
+  dependencies: [frontend_code],
+  kwargs: default_bin_args,
+)
+bin_targets += pg_combinebackup
+
+tests += {
+  'name': 'pg_combinebackup',
+  'sd': meson.current_source_dir(),
+  'bd': meson.current_build_dir()
+}
